/***************************************************************************
 *   Copyright (C) 2004, 2005 Thomas Nagy                                  *
 *   tnagy2^8@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _KDISSGENERATORWIZARD_H
#define _KDISSGENERATORWIZARD_H

#include <kwizard.h>
#include <qvaluelist.h>

class DGenerator;
class QWidget;
class QListViewItem;
class generatorp1;
class generatorp2;
class DGenerator;
class DDataControl;
class generatorwizard : public KWizard
{
	Q_OBJECT
	public:
		generatorwizard(QWidget *parent, const char *name);
		~generatorwizard();
		void setgeneratorlist(QValueList<DGenerator*> & genlist);
		void setgeneratordata(DDataControl*);

	private:
		generatorp1* m_page1;
		generatorp2* m_page2;

		bool isvalidlocation();

		DGenerator * m_selected;
		DDataControl * m_data;
		
	private slots:
		void updatelocationlabel();
		void updateselectedtemplate(QListViewItem*);
		void checksteps();

	protected:
		virtual void accept();
};

#endif // _KDISSGENERATORWIZARD_H

