/***************************************************************************
 *   Copyright (C) 2005 Thomas Nagy                                        *
 *   tnagy2^8@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KDIKONSOLE_H
#define KDIKONSOLE_H

#include <qvbox.h>

class KDIKonsole : public QVBox
{
    Q_OBJECT

    public:
	KDIKonsole( QWidget* parent, const char* name=0);
	~KDIKonsole();

    public slots:
        void setDirectory(const QString & dir);
	void activate();

    private slots:
        void slotDestroyed();
	void respawn();

    protected:
	void showEvent(QShowEvent *ev);

    private:
	KParts::ReadOnlyPart *m_part;
	bool m_haskonsole;
};

#endif
